/* Contrast (using bitwise operations)
 created January 18, 2006
 updated December 4, 2006 */

size(800, 400); 
PImage img = loadImage("harbor.jpg");
PImage img2 = createImage(img.width, img.height, RGB);
arraycopy(img.pixels, img2.pixels);

float threshold = 127.5;
float contrast = .5; // pos or neg values
loadPixels();
for(int i = 0; i< img.width * img.height; i++){
  // separate out component color values
  int r =  img2.pixels[i] >> 16 & 0xFF;
  int g =  img2.pixels[i] >> 8 & 0xFF;
  int b =  img2.pixels[i] & 0xFF;
  int a =  img2.pixels[i] >> 24 & 0xFF;

  // red
  r = int(r*(1.0 + (contrast)*((r-threshold)*.01)));
  r = constrain(r, 0, 255);

  // green
  g = int(g*(1.0 + (contrast)*((g-threshold)*.01)));
  g = constrain(g, 0, 255);

  // blue
  b = int(b*(1.0 + (contrast)*((b-threshold))*.01));
  b = constrain(b, 0, 255);

  // combine components back into a 32-bit integer
  img2.pixels[i] = (a << 24) | (r << 16) | (g << 8) | b;
}
//draw images
image(img, 0, 0);
image(img2, width/2, 0);

