void checkObjectCollision(Ball[] b, Vect2D[] v){
  float d = dist(b[0].x, b[0].y, b[1].x, b[1].y);
  if (d < b[0].r + b[1].r){
    
    /* calculate final velocities based on
      Law of Conservation of Momentum */
    float finalVel0 = ((b[0].m - b[1].m) * v[0].vx + 2 *
          b[1].m * v[1].vx) / (b[0].m + b[1].m);
    float finalVel1 = ((b[1].m - b[0].m) * v[1].vx + 2 *
           b[0].m * v[0].vx) / (b[0].m + b[1].m);

    v[0].vx = finalVel0;
    v[1].vx = finalVel1;
  }
}

