public class MyController extends PApplet {
  IG3D i;
  Table t;
  float eyeX, eyeY, angle, cntrX, cntrY, axisX, axisY, axisZ;
  void setup(){
    size(400, 400, P3D);
    noStroke();
    fill(126, 63, 20);
    // initialize camera arguments
    eyeX = width/2;
    eyeY = height/2;
    cntrX = width/2;
    cntrY = height/2;
    angle = 60;
    axisY = 1.0;

    i = new IG3D(this);
    t = new Table(200, 140, 100);
  }
  void draw(){
    background(0);
    camera(eyeX, eyeY, (height/2.0) / tan(PI*angle / 360.0), cntrX, cntrY, 0, axisX, axisY, axisZ);
    lights();
    translate(width/2, height/2);
    rotateX(PI/-4);
    rotateY(PI/8);
    i.render(t);
    printCamera();
  }

  void mouseMoved(){
    eyeX = mouseX;
    eyeY = mouseY;
  }

  void mouseDragged(){
    cntrX = mouseX;
    cntrY = mouseY;
  }

  void keyPressed() { 
    if(key == CODED) { 
      if (keyCode == UP) { 
        //zoom in 
        angle++; 
      } 
      else if (keyCode == DOWN) { 
        //zoom out 
        angle--; 
      } 
    } 
    else {
      // set which axis points up
      if (key == 'x') { 
        axisX = 1.0;
        axisY = 0;
        axisZ = 0;
      } 
      else if (key == 'y') { 
        axisX = 0;
        axisY = 1.0;
        axisZ = 0;
      } 
      else if (key == 'z'){ 
        axisX = 0;
        axisY = 0;
        axisZ = 1.0;
      }
    }
  }
}

