// Catmull-Rom spline curve
// Curve Tightness
size(600, 400);
background(0);
stroke(255);
strokeWeight(2);
smooth();
int curveWdth = 50;
int cols = 5;
int xPadding = (width-curveWdth*cols)/(cols+1);
int x = xPadding;

for (int i=-2; i<3; i++){
  curveTightness(i);
  Point p0 = new Point(x, 100);
  Point p1 = new Point(x+curveWdth, 100);
  Point p2 = new Point(x+curveWdth, 300);
  Point p3 = new Point(x, 300);
  Point p4 = new Point(x, 200);
  x+=curveWdth+xPadding;

  //curve segments
  noFill(); // comment this line out  to see how the curve fills
  curve(p4.x, p4.y, p0.x, p0.y, p1.x, p1.y, p2.x, p2.y);
  curve(p0.x, p0.y, p1.x, p1.y, p2.x, p2.y, p3.x, p3.y);
  curve(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y);
  curve(p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, p0.x, p0.y );

  //control points
  fill(255);
  ellipse(p0.x, p0.y, 5, 5);
  ellipse(p1.x, p1.y, 5, 5);
  ellipse(p2.x, p2.y, 5, 5);
  ellipse(p3.x, p3.y, 5, 5);
  ellipse(p4.x, p4.y, 5, 5);
}

